Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tinytree
Class TinyNodeImpl

    java.lang.Object
      net.sf.saxon.tinytree.TinyNodeImpl

All Implemented Interfaces:
  FingerprintedNode, Item, NodeInfo, javax.xml.transform.Source, javax.xml.transform.SourceLocator, ValueRepresentation

Direct Known Subclasses:
  net.sf.saxon.tinytree.TinyParentNodeImpl

public abstract class TinyNodeImpl
extends java.lang.Object
implements NodeInfo, FingerprintedNode, javax.xml.transform.SourceLocator

A node in a TinyTree representing an XML element, character content, or attribute.

This is the top-level class in the implementation class hierarchy; it essentially contains all those methods that can be defined using other primitive methods, without direct access to data.

Field Summary
`static char[]` | `NODE_LETTER` Chararacteristic letters to identify each type of node, indexed using the node type values.
`protected int` | `nodeNr`
`protected TinyNodeImpl` | `parent`
`protected TinyTree` | `tree`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, LOCAL_NAMESPACES, NO_NAMESPACES`

Constructor Summary
`TinyNodeImpl()`

Method Summary
`int` | `compareOrder(NodeInfo other)` Determine the relative position of this node and another node, in document order.
`java.lang.String` | `generateId()` Get a character string that uniquely identifies this node
`java.lang.String` | `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`java.lang.String` | `getBaseURI()` Get the base URI for the node.
`int` | `getColumnNumber()` Get the column number of the node.
`Configuration` | `getConfiguration()` Get the configuration
`int[]` | `getDeclaredNamespaces(int[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`java.lang.String` | `getDisplayName()` Get the display name of this node (a lexical QName).
`int` | `getDocumentNumber()` Get the document number of the document containing this node (Needed when the document isn't a real node, for sorting free-standing elements)
`DocumentInfo` | `getDocumentRoot()` Get the root (document) node
`int` | `getFingerprint()` Get the fingerprint of the node, used for matching names
`int` | `getLineNumber()` Get the line number of the node within its source document entity
`java.lang.String` | `getLocalPart()` Get the local part of the name of this node.
`int` | `getNameCode()` Get the name code of the node, used for matching names
`NamePool` | `getNamePool()` Get the NamePool for the tree containing this node
`NodeInfo` | `getParent()` Find the parent node of this node.
`java.lang.String` | `getPrefix()` Get the prefix part of the name of this node.
`java.lang.String` | `getPublicId()` Get the public identifier of the document entity containing this node.
`NodeInfo` | `getRoot()` Get the root node of the tree (not necessarily a document node)
`protected long` | `getSequenceNumber()` Get the node sequence number (in document order).
`java.lang.CharSequence` | `getStringValueCS()` Get the value of the item as a CharSequence.
`java.lang.String` | `getSystemId()` Get the system ID for the entity containing the node.
`int` | `getTypeAnnotation()` Get the type annotation of this node, if any
`SequenceIterator` | `getTypedValue()` Get the typed value of this node.
`java.lang.String` | `getURI()` Get the URI part of the name of this node.
`boolean` | `hasChildNodes()` Determine whether the node has any children.
`boolean` | `isSameNodeInfo(NodeInfo other)` Determine whether this is the same node as another node
`AxisIterator` | `iterateAxis(byte axisNumber)` Return an iterator over all the nodes reached by the given axis from this node
`AxisIterator` | `iterateAxis(byte axisNumber, NodeTest nodeTest)` Return an iterator over the nodes reached by the given axis from this node
`void` | `sendNamespaceDeclarations(Receiver out, boolean includeAncestors)` Output all namespace nodes associated with this element.
`protected void` | `setParentNode(TinyNodeImpl parent)` Set the parent of this node.
`void` | `setSystemId(java.lang.String uri)` Set the system id of this node.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.om.NodeInfo
`copy, getNodeKind, getStringValue`

Field Detail

### tree

    protected TinyTree tree

### nodeNr

    protected int nodeNr

### parent

    protected TinyNodeImpl parent

### NODE_LETTER

    public static final char[] NODE_LETTER

  Chararacteristic letters to identify each type of node, indexed using the node type values. These are used as the initial letter of the result of generate-id()

Constructor Detail

### TinyNodeImpl

    public TinyNodeImpl()

Method Detail

### getStringValueCS

    public java.lang.CharSequence getStringValueCS()

  Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.

  Specified by:
    `getStringValueCS` in interface `Item`

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of this node, if any

  Specified by:
    `getTypeAnnotation` in interface `NodeInfo`
  Returns:
    the type annotation of the node.
  See Also:
    `Type`

### getColumnNumber

    public int getColumnNumber()

  Get the column number of the node. The default implementation returns -1, meaning unknown

  Specified by:
    `getColumnNumber` in interface `javax.xml.transform.SourceLocator`

### getPublicId

    public java.lang.String getPublicId()

  Get the public identifier of the document entity containing this node. The default implementation returns null, meaning unknown

  Specified by:
    `getPublicId` in interface `javax.xml.transform.SourceLocator`

### getTypedValue

    public SequenceIterator getTypedValue()
                                   throws XPathException

  Get the typed value of this node. If there is no type annotation, we return the string value, as an instance of xdt:untypedAtomic

  Specified by:
    `getTypedValue` in interface `Item`
  Returns:
    the typed value of the item. In general this will be a sequence
  Throws:
    `XPathException` - where no typed value is available, e.g. for an element with complex content

### setSystemId

    public void setSystemId(java.lang.String uri)

  Set the system id of this node.
  This method is present to ensure that the class implements the javax.xml.transform.Source interface, so a node can be used as the source of a transformation.

  Specified by:
    `setSystemId` in interface `javax.xml.transform.Source`

### setParentNode

    protected void setParentNode(TinyNodeImpl parent)

  Set the parent of this node. Providing this information is useful, if it is known, because otherwise getParent() has to search backwards through the document.

### isSameNodeInfo

    public boolean isSameNodeInfo(NodeInfo other)

  Determine whether this is the same node as another node

  Specified by:
    `isSameNodeInfo` in interface `NodeInfo`
  Parameters:
    `other` - the node to be compared with this node
  Returns:
    true if this Node object and the supplied Node object represent the same node in the tree.

### getSystemId

    public java.lang.String getSystemId()

  Get the system ID for the entity containing the node.

  Specified by:
    `getSystemId` in interface `NodeInfo`
  Returns:
    the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

### getBaseURI

    public java.lang.String getBaseURI()

  Get the base URI for the node. Default implementation for child nodes gets the base URI of the parent node.

  Specified by:
    `getBaseURI` in interface `NodeInfo`
  Returns:
    the base URI of the node

### getLineNumber

    public int getLineNumber()

  Get the line number of the node within its source document entity

  Specified by:
    `getLineNumber` in interface `NodeInfo`
  Returns:
    the line number of the node in its original source document; or -1 if not available

### getSequenceNumber

    protected long getSequenceNumber()

  Get the node sequence number (in document order). Sequence numbers are monotonic but not consecutive. The sequence number must be unique within the document (not, as in previous releases, within the whole document collection). For document nodes, elements, text nodes, comment nodes, and PIs, the sequence number is a long with the sequential node number in the top half and zero in the bottom half. The bottom half is used only for attributes and namespace.

### compareOrder

    public final int compareOrder(NodeInfo other)

  Determine the relative position of this node and another node, in document order. The other node will always be in the same document.

  Specified by:
    `compareOrder` in interface `NodeInfo`
  Parameters:
    `other` - The other node, whose position is to be compared with this node
  Returns:
    -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the node, used for matching names

  Specified by:
    `getFingerprint` in interface `NodeInfo`
  Returns:
    an integer fingerprint; two nodes with the same fingerprint have the same expanded QName

### getNameCode

    public int getNameCode()

  Get the name code of the node, used for matching names

  Specified by:
    `getNameCode` in interface `NodeInfo`
  Returns:
    an integer name code, which may be used to obtain the actual node name from the name pool
  See Also:
    `allocate`, `getFingerprint`

### getPrefix

    public java.lang.String getPrefix()

  Get the prefix part of the name of this node. This is the name before the ":" if any.

  Specified by:
    `getPrefix` in interface `NodeInfo`
  Returns:
    the prefix part of the name. For an unnamed node, return "".

### getURI

    public java.lang.String getURI()

  Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.

  Specified by:
    `getURI` in interface `NodeInfo`
  Returns:
    The URI of the namespace of this node. For an unnamed node, or for an element or attribute in the default namespace, return an empty string.

### getDisplayName

    public java.lang.String getDisplayName()

  Get the display name of this node (a lexical QName). For elements and attributes this is [prefix:]localname. The original prefix is retained. For unnamed nodes, the result is an empty string.

  Specified by:
    `getDisplayName` in interface `NodeInfo`
  Returns:
    The display name of this node. For a node with no name, return an empty string.

### getLocalPart

    public java.lang.String getLocalPart()

  Get the local part of the name of this node.

  Specified by:
    `getLocalPart` in interface `NodeInfo`
  Returns:
    The local name of this node. For a node with no name, return "".

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber)

  Return an iterator over all the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - Identifies the required axis, eg. Axis.CHILD or Axis.PARENT
  Returns:
    a AxisIteratorImpl that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### iterateAxis

    public AxisIterator iterateAxis(byte axisNumber,
                                    NodeTest nodeTest)

  Return an iterator over the nodes reached by the given axis from this node

  Specified by:
    `iterateAxis` in interface `NodeInfo`
  Parameters:
    `axisNumber` - Identifies the required axis, eg. Axis.CHILD or Axis.PARENT
    `nodeTest` - A pattern to be matched by the returned nodes.
  Returns:
    a AxisIteratorImpl that scans the nodes reached by the axis in turn.
  See Also:
    `Axis`

### getParent

    public NodeInfo getParent()

  Find the parent node of this node.

  Specified by:
    `getParent` in interface `NodeInfo`
  Returns:
    The Node object describing the containing element or root node.

### hasChildNodes

    public boolean hasChildNodes()

  Determine whether the node has any children.

  Specified by:
    `hasChildNodes` in interface `NodeInfo`
  Returns:
    `true` if this node has any attributes, `false` otherwise.

### getAttributeValue

    public java.lang.String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### getRoot

    public NodeInfo getRoot()

  Get the root node of the tree (not necessarily a document node)

  Specified by:
    `getRoot` in interface `NodeInfo`
  Returns:
    the NodeInfo representing the root of this tree

### getDocumentRoot

    public DocumentInfo getDocumentRoot()

  Get the root (document) node

  Specified by:
    `getDocumentRoot` in interface `NodeInfo`
  Returns:
    the DocumentInfo representing the containing document

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration

  Specified by:
    `getConfiguration` in interface `NodeInfo`

### getNamePool

    public NamePool getNamePool()

  Get the NamePool for the tree containing this node

  Specified by:
    `getNamePool` in interface `NodeInfo`
  Returns:
    the NamePool

### sendNamespaceDeclarations

    public void sendNamespaceDeclarations(Receiver out,
                                          boolean includeAncestors)
                                   throws XPathException

  Output all namespace nodes associated with this element. Does nothing if the node is not an element.

  Specified by:
    `sendNamespaceDeclarations` in interface `NodeInfo`
  Parameters:
    `out` - The relevant outputter
    `includeAncestors` - True if namespaces declared on ancestor elements must
  Throws:
    `XPathException`

### getDeclaredNamespaces

    public int[] getDeclaredNamespaces(int[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### generateId

    public java.lang.String generateId()

  Get a character string that uniquely identifies this node

  Specified by:
    `generateId` in interface `NodeInfo`
  Returns:
    a string.

### getDocumentNumber

    public int getDocumentNumber()

  Get the document number of the document containing this node (Needed when the document isn't a real node, for sorting free-standing elements)

  Specified by:
    `getDocumentNumber` in interface `NodeInfo`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD